Some audio files of type "flac" are not found or won't play with drag and drop

Bug #491543 reported by mixerdj on 2009-12-02
30
This bug affects 5 people
Affects Status Importance Assigned to Milestone
Mixxx
Medium
Bill Good
1.7
Medium
Bill Good
1.8
Medium
Sean M. Pappalardo

Bug Description

When searching the library for songs saved in the file format "flac", some files of this type are not found/listed in the library and can not be played or added to playlists/queue etc. with drag/drop.
These files play OK with eg. "WinAmp"
The "test" facility of the FLAC-frontend software (1.7.1) indicate these files as OK.

This applies for some "external" files (downloaded from the internet) and files created/ripped by myself with FLAC-frontend (ver. 1.7.1)

(Some flac-type files are found and can be added/played with drag/drop however)

Suspect difference in flac files cause this

No errors are reported or indicated, just nothing happens (Cursor changes correctly to include a "+" sign when hovering over the appropriate fields)

Mixxx 1.7.1 / outline / 11 pm Dark Mixxx
OS: Windows XP

Related branches

Try with v1.7.2 of Mixxx. Is is still a problem?

Changed in mixxx:
status: New → Incomplete
summary: - Some audio files of type "flaq" are not found or won't play with drag
+ Some audio files of type "flac" are not found or won't play with drag
and drop

Hello,

It seems the flac files are found now, ie. they are listed in eg.
"browse" mode.
Double clicking or drag/drop still does not seem to work however in v1.7.2

Regards,

Henry

Pegasus schreef:
> Try with v1.7.2 of Mixxx. Is is still a problem?
>
> ** Changed in: mixxx
> Status: New => Incomplete
>
> ** Summary changed:
>
> - Some audio files of type "flaq" are not found or won't play with drag and drop
> + Some audio files of type "flac" are not found or won't play with drag and drop
>
>

Do other FLAC files or MP3s play with darg & drop?

Hello Pegasus,

Yes, many flac files work OK, some do not.
MP3 files are OK

Henry.

Pegasus schreef:
> Do other FLAC files or MP3s play with darg & drop?
>
>

For the files that don't work, does anything show up in the mixxx.log file about them? Can you attach an example file please?

mixerdj (henry-vredegoor) wrote :

Pegasus schreef:

Here is one of the files that won't play and the associated log file.
I created the log file by selecting the flac file and selecting "Open
with" and Mixxx as the program.
But this doesn't differ from trying to start it from within Mixx.

The log file indeed shows an error:

Debug: [Main]: libsndfile: ERR opening file.
Debug: [Main]: Could not parse "03 - I Can't Make You Love Me - Bonnie
Raitt -Luck Of The Draw -1991 - Rock.flac"

Sorry the flac file cannot be sent via my mail provider because of it's
size (28 MByte)
I will have to search a smaller flac file that doesn't work to send you
later.

Regards,

Henry.

> For the files that don't work, does anything show up in the mixxx.log
> file about them? Can you attach an example file please?
>
>

mixerdj (henry-vredegoor) wrote :
ultraschall (stepaul) wrote :

Usin Win XP and Mixxx 1.7.2 i get also this bug. But if i remember right, id say i had that kinda problems also in earlier verisons of Mixxx than 1.7.1 .
If i do a rescan through my whole library, i get about 1000 lines of this in my mixx.log

Debug: [LibraryScanner 1]: libsndfile: ERR opening file.
Debug: [LibraryScanner 1]: Could not parse "name_it_whatever.flac"

I can confirm that the file mixerdj added is a file that causes this bug also on my side. It only shows up in 'Browse' mode, but its unloadable to any mixer, like all those somehow 'special' files.

But as those files seem not to be special to any other media player, and the flac reference de/encoder just tests those files without errors as clean flac encoded audio files, it seems rly a Mixxx/libsndfile bug.

Tried also to find the difference of those flac files with the workin ones, i had no luck, namechangin, changin meta data, nothin seemed to work to make em loadable in Mixxx.

ultraschall (stepaul) wrote :

Today i found some flac files which changed my thoughts on this completely!

Added some new flacs to my library, they showed up fine in Mixxx Library, but the Duration of those files was set to "?" , and i couldnt load them into any deck.

Other Media Players like vlc or winamp played the files, but i couldnt seek through em as they had also no duration listed.

Tryin to view the porperties of the files Audioshell failed to read those, Foobar2000 could show em, and the data looked fine, but i saw that the encoder was reference libFLAC with some 64 fix. I tested them in my FLACFrontend, and they were fine.

But i thought maybe it might help to decode them to wavs and then encode them back to flac. And wow, that rly fixed it!
Edited some Metadata, scanned library in Mixxx again, they showed up, with duration, and playable in any deck.

So now it came to my mind i just tested all those other flac files i have (that dont work in Mixxx, but dont have that curious duration problem) but didnt try to de- AND re-encode em.
Tried another Album that didnt work in Mixxx, de/rencoded, and wow, again that fixed it, showed up and was playable!

Then i tried the same procedure on the file mixerdj posted here, same result, after de/reencodin the file shows up and is playable.

SO, after experiencin this now, this should more likely be an ugly flac Metadata or whatever file corruption, somehow for heavens sake the audio data seems not affected as they decode fine. Other Media Players seem to handle that quite well it seems, as those files played well in all except Mixxx, only the files i mentioned first with the duration problem where f.cked up so much it seems, all media players couldnt seek, but play.

As all those problematic files in Mixxx worked fine after a new reference libFLAC de/reencode, id say some programs used in originally creatin those files seem somehow not to follow the standards. I am rly not sure any more if Mixxx is responsible for fixin that, or if it should handle other encoders/metadata-editors faults (as other media players seem to do like vlc, there all files worked).

I am pretty sure those problems should be documented somewhere, there must be many other people havin those strange problems with some flac files. Gonna search a bit these days, maybe i can provide the correct cause why all this happens.

At least i can provide somehow a 'FIX' to this problem:

decode your files to wav and then encode back to flac, by usin reference libFLAC 1.2.1b from http://flac.sourceforge.net/download.html

markpitchless (markpitchless) wrote :

I'm seeing the same problem using 1.7 and 1.8 beta on Mac OS 10.6.3. Trying to load the flac into a deck does nothing in 1.7 and just sets the name in 1.8. No wave form and no play. Files all play in VLC. All the flacs I tried have a duration and are scrubbable in VLC.
Flacs downloaded from here: http://brutalattackrecords.npage.de/index.html - none of the breakcore tracks work as flac.

Log:
Debug: [Reader 1]: libsndfile: Error opening file "/Users/mda/Music/Brutal Attack Records/BRA001 - KoZe.oNe - Get Up.flac"
Debug: [Main]: libsndfile: ERR opening file.
Debug: [AnalyserQueue 1]: libsndfile: Error opening file "/Users/mda/Music/Brutal Attack Records/BRA001 - KoZe.oNe - Get Up.flac"
Debug: [AnalyserQueue 1]: Skipping invalid file: "/Users/mda/Music/Brutal Attack Records/BRA001 - KoZe.oNe - Get Up.flac"

Tried re-encoding the file using Audacity and it didn't help. I think that these 'broken' flac files are going to pretty common and Mixxx needs a real fix. Having to re-encode everything with a specific encoder is only a temp fix, most users are not going to like if if their files play every where except mixxx. Maybe it needs fixing in the what ever lib is being used for flac reading (or change lib).

markpitchless (markpitchless) wrote :

Just encoded some wavs as flac using Max (http://sbooth.org/Max/) on Mac OS and again these fail to work in Mixxx.
The file meta data says encoded using: reference libFLAC 1.2.1 20070917.

All of the files I have that wont play also play fine in Songbird, VLC, Traktor. So far Mixxx is the only app that can't handle the files so while it is tempting to say they are just non-spec conforming files, given they play everywhere else, I think there needs to be a Mixxx fix. I wondered if this could be a version thing but the version of encoder looks pretty close, not sure how significant the b is.

Does mixxx have a bit rate limit? Flac files by there nature will tend to be high e.g. the file I'm looking at is 698kpbs. Although that shouldn't stop it reading the meta data at minimum.

I agree, this needs to be fixed, especially since I have most of my music in FLAC format!
Mixxx just uses libsndfile for FLAC decoding at the moment, so it would be best to file a bug with them too. I'll see if I can get it to give us a more meaningful error in Mixxx at least for now.

Changed in mixxx:
assignee: nobody → Pegasus (pegasus-renegadetech)
importance: Undecided → Medium
status: Incomplete → Confirmed
Erik de Castro Lopo (erikd) wrote :

If you look at the problem files in a hex editor, you will see that it isn't a pure FLAC file but rather a FLAC file with an ID3 header.

The libsndfile development version (in Bzr at http://www.mega-nerd.com/Bzr/libsndfile-dev/ ) has already been fixed to read these files. There is no scheduled release date for the next libsndfile version, but it is being worked on.

API use fixes and error reporting added in 1.7 branch r2567 (merged to trunk in r2409.)

Changed in mixxx:
status: Confirmed → Triaged

I'll investigate including the latest libsndfile trunk with Mixxx 1.8.0 on Windows at least.

Hal Vaughan (hal-halblog) wrote :

I'm using 1.7.2 and 1.8.0 beta 1. What I'm talking about here is what happens in 1.8.0 beta 1.

I'm having this problem, but have more symptoms I haven't seen mentioned. My FLAC files were created with crip on Linux or the later ones were created with Max on OS X. If you're not familiar with crip, it's FOSS and under GPL. It's in Perl, but I can't remember which library it uses to get tag data or encode. I see I'm not the only one here using Max.

Many of my FLAC files have no artist listed show no artist, while a number of others show the track number in place of the artist. ALL my FLAC files have a duration of 0:00. There are some I've created with Audacity that show up differently, but those still show something like the filename or the title as the artist.

These same files play in Songbird, played in Amarok on Linux and play in Amarok built using MacPorts on OS X. They also play in VLC. And by "play" I mean they come up with all the right information and play perfectly.

I'll be glad to post a logfile if you tell me where it is and I can post a sample file if you need it.

Bill Good (bkgood) wrote :

I've linked my features_flac branch, which decodes flac using libFLAC in a SoundSourceFLAC. Metadata isn't yet implemented but should be by the end of the weekend and likely sooner. It plays every FLAC file I've thrown at it, including one encoded myself, "I Can't Make You Love Me" (attached to this bug), and one of the breakcore files mentioned in comment 10 (the commented said that they all didn't work, so I figured trying one meant they'd probably all work, and I've been staring at this monitor for quite a while now :)).

It currently is enabled by defines, so anyone interested it trying it out will need to build with `scons flac=1`. It doesn't add any dependencies to Mixxx that weren't already there, as mixxx depends on sndfile which depends on libflac (at least it links on my system) for flac support.

I believe the class to be stable, it's a fairly simple pair of files really; the source file is something like 300 lines long.

@Hal -- the bug regarding song durations being reset to 0:00 on play is being addressed at https://bugs.launchpad.net/mixxx/+bug/598641 (it's a bug for all formats but mp3). Otherwise, hopefully my branch (if adopted) will solve the rest of your problems. :)

One thing I will mention -- I don't know that I can [easily or at all] make this class support ID3v2 tags in FLAC files. Frankly, as Erik said, they don't belong in a true FLAC file (I'm grateful libflac will even decode them truthfully, I probably wouldn't be as nice of a decoder-library maintainer :)) and make the file inherently corrupt just being there. Luckily, from what I've seen, tagging programs which add ID3v2 tags seem to also be adding flac tags.

Bill Good (bkgood) wrote :

Ok, metadata's added and pushed. If anyone wouldn't mind giving it a test, I'd very much appreciate it (I don't have much FLAC, although as I said, nothing's been able to break it yet).

Hal Vaughan (hal-halblog) wrote :

I tested it with Beta 2 and the metadata wasn't being handled. If you've got a link to a newer build that tests this, I'll be glad to try it.

Sean, if you have time, can you please make a windows build of Bill's flac
branch for these users to test?

Thanks,
Albert

On Jul 18, 2010 11:00 PM, "Hal Vaughan" <email address hidden> wrote:

I tested it with Beta 2 and the metadata wasn't being handled. If
you've got a link to a newer build that tests this, I'll be glad to try
it.

--
Some audio files of type "flac" are not found or won't play with drag and
drop
https://bugs.lau...

Hal Vaughan (hal-halblog) wrote :

Any chance of getting a build of the test version for OS X? Or would that be too much of a pain?

Or would it be too hard for someone not familiar with the source and who hasn't been doing any programming in a good while (i.e. me) to build it on OS X?

Greg Robinson (softwarecommie) wrote :

I can't seem to do anything with ID3-laden FLACs on 1.7.2 and 1.8.0~beta2 with OS X.
1.7.2 doesn't give me any error message; it just fails to load the files.
1.8.0~beta2 adds these "special" FLAC tracks to the library (with incomplete/incorrect tags), but tells me that it could not load the requested file when I try to play it.

It's not that big of a deal to strip away the tags in about 30% of my library, but this is common enough that it seems reasonable to make the decoder support what is no longer standard. Any idea when the more tolerant lib will be included in Mixxx?

Hi Greg,

Unfortunately we are stuck with libsndfile to parse the FLAC metadata
and As far as I know it is onlycapable of parsing Xiph / Vorbis
comments. We hope to address this as early as mixxx 1.9.0 around
December.

Thanks,
RJ

On Tuesday, September 14, 2010, Greg Robinson <email address hidden> wrote:
> I can't seem to do anything with ID3-laden FLACs on 1.7.2 and 1.8.0~beta2 with OS X.
> 1.7.2 doesn't give me any error message; it just fails to load the files.
> 1.8.0~beta2 adds these "special" FLAC tracks to the library (with incomplete/incorrect tags), but tells me that it could not load the requested file when I try to play it.
>
> It's not that big of a deal to strip away the tags in about 30% of my
> library, but this is common enough that it seems reasonable to make the
> decoder support what is no longer standard. Any idea when the more
> tolerant lib will be included in Mixxx?
>
> --
> Some audio files of type "flac" are not found or won't play with drag and drop
> https://bugs.launchpad.net/bugs/491543
> You received this bug notification because you are subscribed to Mixxx.
>

Bill Good (bkgood) wrote :

Greg,
I know it won't be 1.8, but maybe 1.9? It's not on the timeline but I'm hoping it's a small enough change to make it in by then.

Do your FLAC files all have ID3 tags and not FLAC tags? My code doesn't account for this, it only reads FLAC tags as, officially, they are the only supported metadata of the format. If there's a strong showing of ID3-only users, I may look for ID3 tags as well.

Greg Robinson (softwarecommie) wrote :

I'd say about 30% of my FLACs have ID3. They're from a number of friends' music projects, but I don't know how representative they are of the general user base. December is pretty quick turnaround for a low priority quirks mode. It's exciting to see this project's clip.

Bill Good (bkgood) on 2010-09-29
Changed in mixxx:
assignee: Pegasus (pegasus-renegadetech) → Bill Good (bkgood)
status: Triaged → In Progress
milestone: none → 1.9.0
Erik de Castro Lopo (erikd) wrote :

RJ Ryan wrote:

> Hi Greg,
>
> Unfortunately we are stuck with libsndfile to parse the FLAC metadata
> and As far as I know it is onlycapable of parsing Xiph / Vorbis
> comments. We hope to address this as early as mixxx 1.9.0 around
> December.

Verion 1.0.22 of libsndfile has just been releases and handles
FLAC files with pre-pended ID3 meta data.

Erik
--
----------------------------------------------------------------------
Erik de Castro Lopo
http://www.mega-nerd.com/

Yes, I just saw that Erik, thank you.

I'm going to repackage 1.8.0 for Windows with sndfile 1.0.22 since it tests good for me on the FLACs mentioned in this bug and is otherwise just a bug fix release. I can't promise the head developer will agree with this so close to release though, so the final released version may not include this. I'll post a download link here if not.

Updated libsndfile v1.0.22 released in 1.8.x in Windows.

Bill Good (bkgood) on 2010-11-14
Changed in mixxx:
status: In Progress → Fix Committed
Marc Rechté (marc3) wrote :

Typical file that cannot be opened by Mixxx 1.8.2 on Windows 7

Erik de Castro Lopo (erikd) wrote :

Marc Rechté wrote:

> Typical file that cannot be opened by Mixxx 1.8.2 on Windows 7
>
> ** Attachment added: "07 - Tequila.flac"
> https://bugs.launchpad.net/mixxx/+bug/491543/+attachment/1760536/+files/07%20-%20Tequila.flac

This file is read correctly by the current version of libsndfile,
version 1.0.23.

Erik
--
----------------------------------------------------------------------
Erik de Castro Lopo
http://www.mega-nerd.com/

RJ Skerry-Ryan (rryan) on 2011-02-20
Changed in mixxx:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Related blueprints